      subroutine cyax ( n, alpha, x, incx, y, incy )
c#######################################################################
c
c Compute Y = alpha * X
c
c Last modified:   May 7, 1992
c
c#######################################################################
c Last entry to update in Y
      integer n
c Scalar multiplier
      complex alpha
c Vector multiplicand
      complex x(*)
c Increment for X vector
      integer incx
c Result vector
      complex y(*)
c Increment for Y vector
      integer incy
c Local (temporary) variables
      integer i, ix, iy
c Local (temporary) variable
      complex ax
c#######################################################################
c
c incx == 0 and incy == 1
c
c#######################################################################
      if(incx.eq.0.and.incy.eq.1) then 
          ax = alpha * x(1)
          do 2000  i = 1,n
              y(i) = ax
2000      continue
c#######################################################################
c
c incx == 1 and incy == 1
c
c#######################################################################
      elseif(incx.eq.1.and.incy.eq.1) then 
          if(alpha.eq.1.0) then 
              do 2002  i = 1,n
                  y(i) = x(i)
2002          continue
          else
              do 2004  i = 1,n
                  y(i) = alpha * x(i)
2004          continue
          endif
c#######################################################################
c
c incx == 1 and incy != 1
c
c#######################################################################
      elseif(incx.eq.1) then 
          iy = 1
          if(alpha.eq.1.0) then 
              do 2006  i = 1,n
                  y(iy) = x(i)
                  iy = iy + incy
2006          continue
          else
              do 2008  i = 1,n
                  y(iy) = alpha * x(i)
                  iy = iy + incy
2008          continue
          endif
c#######################################################################
c
c incx != 1 and incy == 1
c
c#######################################################################
      elseif(incy.eq.1) then 
          ix = 1
          if(alpha.eq.1.0) then 
              do 2010  i = 1,n
                  y(i) = x(ix)
                  ix = ix + incx
2010          continue
          else
              do 2012  i = 1,n
                  y(i) = alpha * x(ix)
                  ix = ix + incx
2012          continue
          endif
c#######################################################################
c
c incx != 1 and incy != 1
c
c#######################################################################
      else
          iy = 1
          if(alpha.eq.1.0) then 
              do 2014  i = 1,n,incx
                  y(iy) = x(i)
                  iy = iy + incy
2014          continue
          else
              do 2016  i = 1,n,incx
                  y(iy) = alpha * x(i)
                  iy = iy + incy
2016          continue
          endif
      endif
      return
      end
      subroutine cgeadd ( a, lda, forma, b, ldb, formb, c, ldc, m, n )
c#######################################################################
c
c Compute C = op(A) + op(B), where
c
c                 { M,           if formm == 'N'
c         op(M) = {
c                 { M transpose, if formm == 'T'
c
c Last modified:   May 7, 1992
c
c#######################################################################
c Leading dimension of matrix A
      integer lda
c Coefficients of A
      complex a(lda,*)
c 'N' or 'T' for op(A)
      character*(*) forma
c Leading dimension of matrix B
      integer ldb
c Coefficients of B
      complex b(ldb,*)
c 'N' or 'T' for op(B)
      character*(*) formb
c Leading dimension of matrix C
      integer ldc
c Result matrix
      complex c(ldc,*)
c Rows of C
      integer m
c Columns of C
      integer n
c Local (temporary) variables
      integer i, j
c First char of forma and formb
      character*1 fma, fmb
c#######################################################################
c
c Translate the formulation of A and B
c
c#######################################################################
      fma = forma(1:1)
      fmb = formb(1:1)
      if(fma.eq.'n') then 
          fma = 'N'
      elseif(fma.eq.'t') then 
          fma = 'T'
      endif
      if(fmb.eq.'n') then 
          fmb = 'N'
      elseif(fmb.eq.'t') then 
          fmb = 'T'
c#######################################################################
c
c C = A + B
c
c#######################################################################
      endif
      if(fma.eq.'N'.and.fmb.eq.'N') then 
          do 2018  j = 1,n
              do 2020  i = 1,m
                  c(i,j) = a(i,j) + b(i,j)
2020          continue
2018      continue
c#######################################################################
c
c      T
c C = A  + B
c
c#######################################################################
      elseif(fma.eq.'T'.and.fmb.eq.'N') then 
          do 2022  j = 1,n
              do 2024  i = 1,m
                  c(i,j) = a(j,i) + b(i,j)
2024          continue
2022      continue
c#######################################################################
c
c          T
c C = A + B
c
c#######################################################################
      elseif(fma.eq.'N'.and.fmb.eq.'T') then 
          do 2026  j = 1,n
              do 2028  i = 1,m
                  c(i,j) = a(i,j) + b(j,i)
2028          continue
2026      continue
c#######################################################################
c
c      T    T
c C = A  + B
c
c#######################################################################
      elseif(fma.eq.'T'.and.fmb.eq.'T') then 
          do 2030  j = 1,n
              do 2032  i = 1,m
                  c(i,j) = a(j,i) + b(j,i)
2032          continue
2030      continue
      endif
      return
      end
      subroutine cgesub ( a, lda, forma, b, ldb, formb, c, ldc, m, n )
c#######################################################################
c
c Compute C = op(A) - op(B), where
c
c                 { M,           if formm == 'N'
c         op(M) = {
c                 { M transpose, if formm == 'T'
c
c Last modified:   May 7, 1992
c
c#######################################################################
c Leading dimension of matrix A
      integer lda
c Coefficients of A
      complex a(lda,*)
c 'N' or 'T' for op(A)
      character*(*) forma
c Leading dimension of matrix B
      integer ldb
c Coefficients of B
      complex b(ldb,*)
c 'N' or 'T' for op(B)
      character*(*) formb
c Leading dimension of matrix C
      integer ldc
c Result matrix
      complex c(ldc,*)
c Rows of C
      integer m
c Columns of C
      integer n
c Local (temporary) variables
      integer i, j
c First char of forma and formb
      character*1 fma, fmb
c#######################################################################
c
c Translate the formulation of A and B
c
c#######################################################################
      fma = forma(1:1)
      fmb = formb(1:1)
      if(fma.eq.'n') then 
          fma = 'N'
      elseif(fma.eq.'t') then 
          fma = 'T'
      endif
      if(fmb.eq.'n') then 
          fmb = 'N'
      elseif(fmb.eq.'t') then 
          fmb = 'T'
c#######################################################################
c
c C = A - B
c
c#######################################################################
      endif
      if(fma.eq.'N'.and.fmb.eq.'N') then 
          do 2034  j = 1,n
              do 2036  i = 1,m
                  c(i,j) = a(i,j) - b(i,j)
2036          continue
2034      continue
c#######################################################################
c
c      T
c C = A  - B
c
c#######################################################################
      elseif(fma.eq.'T'.and.fmb.eq.'N') then 
          do 2038  j = 1,n
              do 2040  i = 1,m
                  c(i,j) = a(j,i) - b(i,j)
2040          continue
2038      continue
c#######################################################################
c
c          T
c C = A - B
c
c#######################################################################
      elseif(fma.eq.'N'.and.fmb.eq.'T') then 
          do 2042  j = 1,n
              do 2044  i = 1,m
                  c(i,j) = a(i,j) - b(j,i)
2044          continue
2042      continue
c#######################################################################
c
c      T    T
c C = A  - B
c
c#######################################################################
      elseif(fma.eq.'T'.and.fmb.eq.'T') then 
          do 2046  j = 1,n
              do 2048  i = 1,m
                  c(i,j) = a(j,i) - b(j,i)
2048          continue
2046      continue
      endif
      return
      end
      subroutine dyax ( n, alpha, x, incx, y, incy )
c#######################################################################
c
c Compute Y = alpha * X
c
c Last modified:   May 7, 1992
c
c#######################################################################
c Last entry to update in Y
      integer n
c Scalar multiplier
      double precision alpha
c Vector multiplicand
      double precision x(*)
c Increment for X vector
      integer incx
c Result vector
      double precision y(*)
c Increment for Y vector
      integer incy
c Local (temporary) variables
      integer i, ix, iy
c Local (temporary) variable
      double precision ax
c#######################################################################
c
c incx == 0 and incy == 1
c
c#######################################################################
      if(incx.eq.0.and.incy.eq.1) then 
          ax = alpha * x(1)
          do 2000  i = 1,n
              y(i) = ax
2000      continue
c#######################################################################
c
c incx == 1 and incy == 1
c
c#######################################################################
      elseif(incx.eq.1.and.incy.eq.1) then 
          if(alpha.eq.1.0) then 
              do 2002  i = 1,n
                  y(i) = x(i)
2002          continue
          else
              do 2004  i = 1,n
                  y(i) = alpha * x(i)
2004          continue
          endif
c#######################################################################
c
c incx == 1 and incy != 1
c
c#######################################################################
      elseif(incx.eq.1) then 
          iy = 1
          if(alpha.eq.1.0) then 
              do 2006  i = 1,n
                  y(iy) = x(i)
                  iy = iy + incy
2006          continue
          else
              do 2008  i = 1,n
                  y(iy) = alpha * x(i)
                  iy = iy + incy
2008          continue
          endif
c#######################################################################
c
c incx != 1 and incy == 1
c
c#######################################################################
      elseif(incy.eq.1) then 
          ix = 1
          if(alpha.eq.1.0) then 
              do 2010  i = 1,n
                  y(i) = x(ix)
                  ix = ix + incx
2010          continue
          else
              do 2012  i = 1,n
                  y(i) = alpha * x(ix)
                  ix = ix + incx
2012          continue
          endif
c#######################################################################
c
c incx != 1 and incy != 1
c
c#######################################################################
      else
          iy = 1
          if(alpha.eq.1.0) then 
              do 2014  i = 1,n,incx
                  y(iy) = x(i)
                  iy = iy + incy
2014          continue
          else
              do 2016  i = 1,n,incx
                  y(iy) = alpha * x(i)
                  iy = iy + incy
2016          continue
          endif
      endif
      return
      end
      subroutine dgeadd ( a, lda, forma, b, ldb, formb, c, ldc, m, n )
c#######################################################################
c
c Compute C = op(A) + op(B), where
c
c                 { M,           if formm == 'N'
c         op(M) = {
c                 { M transpose, if formm == 'T'
c
c Last modified:   May 7, 1992
c
c#######################################################################
c Leading dimension of matrix A
      integer lda
c Coefficients of A
      double precision a(lda,*)
c 'N' or 'T' for op(A)
      character*(*) forma
c Leading dimension of matrix B
      integer ldb
c Coefficients of B
      double precision b(ldb,*)
c 'N' or 'T' for op(B)
      character*(*) formb
c Leading dimension of matrix C
      integer ldc
c Result matrix
      double precision c(ldc,*)
c Rows of C
      integer m
c Columns of C
      integer n
c Local (temporary) variables
      integer i, j
c First char of forma and formb
      character*1 fma, fmb
c#######################################################################
c
c Translate the formulation of A and B
c
c#######################################################################
      fma = forma(1:1)
      fmb = formb(1:1)
      if(fma.eq.'n') then 
          fma = 'N'
      elseif(fma.eq.'t') then 
          fma = 'T'
      endif
      if(fmb.eq.'n') then 
          fmb = 'N'
      elseif(fmb.eq.'t') then 
          fmb = 'T'
c#######################################################################
c
c C = A + B
c
c#######################################################################
      endif
      if(fma.eq.'N'.and.fmb.eq.'N') then 
          do 2018  j = 1,n
              do 2020  i = 1,m
                  c(i,j) = a(i,j) + b(i,j)
2020          continue
2018      continue
c#######################################################################
c
c      T
c C = A  + B
c
c#######################################################################
      elseif(fma.eq.'T'.and.fmb.eq.'N') then 
          do 2022  j = 1,n
              do 2024  i = 1,m
                  c(i,j) = a(j,i) + b(i,j)
2024          continue
2022      continue
c#######################################################################
c
c          T
c C = A + B
c
c#######################################################################
      elseif(fma.eq.'N'.and.fmb.eq.'T') then 
          do 2026  j = 1,n
              do 2028  i = 1,m
                  c(i,j) = a(i,j) + b(j,i)
2028          continue
2026      continue
c#######################################################################
c
c      T    T
c C = A  + B
c
c#######################################################################
      elseif(fma.eq.'T'.and.fmb.eq.'T') then 
          do 2030  j = 1,n
              do 2032  i = 1,m
                  c(i,j) = a(j,i) + b(j,i)
2032          continue
2030      continue
      endif
      return
      end
      subroutine dgesub ( a, lda, forma, b, ldb, formb, c, ldc, m, n )
c#######################################################################
c
c Compute C = op(A) - op(B), where
c
c                 { M,           if formm == 'N'
c         op(M) = {
c                 { M transpose, if formm == 'T'
c
c Last modified:   May 7, 1992
c
c#######################################################################
c Leading dimension of matrix A
      integer lda
c Coefficients of A
      double precision a(lda,*)
c 'N' or 'T' for op(A)
      character*(*) forma
c Leading dimension of matrix B
      integer ldb
c Coefficients of B
      double precision b(ldb,*)
c 'N' or 'T' for op(B)
      character*(*) formb
c Leading dimension of matrix C
      integer ldc
c Result matrix
      double precision c(ldc,*)
c Rows of C
      integer m
c Columns of C
      integer n
c Local (temporary) variables
      integer i, j
c First char of forma and formb
      character*1 fma, fmb
c#######################################################################
c
c Translate the formulation of A and B
c
c#######################################################################
      fma = forma(1:1)
      fmb = formb(1:1)
      if(fma.eq.'n') then 
          fma = 'N'
      elseif(fma.eq.'t') then 
          fma = 'T'
      endif
      if(fmb.eq.'n') then 
          fmb = 'N'
      elseif(fmb.eq.'t') then 
          fmb = 'T'
c#######################################################################
c
c C = A - B
c
c#######################################################################
      endif
      if(fma.eq.'N'.and.fmb.eq.'N') then 
          do 2034  j = 1,n
              do 2036  i = 1,m
                  c(i,j) = a(i,j) - b(i,j)
2036          continue
2034      continue
c#######################################################################
c
c      T
c C = A  - B
c
c#######################################################################
      elseif(fma.eq.'T'.and.fmb.eq.'N') then 
          do 2038  j = 1,n
              do 2040  i = 1,m
                  c(i,j) = a(j,i) - b(i,j)
2040          continue
2038      continue
c#######################################################################
c
c          T
c C = A - B
c
c#######################################################################
      elseif(fma.eq.'N'.and.fmb.eq.'T') then 
          do 2042  j = 1,n
              do 2044  i = 1,m
                  c(i,j) = a(i,j) - b(j,i)
2044          continue
2042      continue
c#######################################################################
c
c      T    T
c C = A  - B
c
c#######################################################################
      elseif(fma.eq.'T'.and.fmb.eq.'T') then 
          do 2046  j = 1,n
              do 2048  i = 1,m
                  c(i,j) = a(j,i) - b(j,i)
2048          continue
2046      continue
      endif
      return
      end
      subroutine syax ( n, alpha, x, incx, y, incy )
c#######################################################################
c
c Compute Y = alpha * X
c
c Last modified:   May 7, 1992
c
c#######################################################################
c Last entry to update in Y
      integer n
c Scalar multiplier
      real alpha
c Vector multiplicand
      real x(*)
c Increment for X vector
      integer incx
c Result vector
      real y(*)
c Increment for Y vector
      integer incy
c Local (temporary) variables
      integer i, ix, iy
c Local (temporary) variable
      real ax
c#######################################################################
c
c incx == 0 and incy == 1
c
c#######################################################################
      if(incx.eq.0.and.incy.eq.1) then 
          ax = alpha * x(1)
          do 2000  i = 1,n
              y(i) = ax
2000      continue
c#######################################################################
c
c incx == 1 and incy == 1
c
c#######################################################################
      elseif(incx.eq.1.and.incy.eq.1) then 
          if(alpha.eq.1.0) then 
              do 2002  i = 1,n
                  y(i) = x(i)
2002          continue
          else
              do 2004  i = 1,n
                  y(i) = alpha * x(i)
2004          continue
          endif
c#######################################################################
c
c incx == 1 and incy != 1
c
c#######################################################################
      elseif(incx.eq.1) then 
          iy = 1
          if(alpha.eq.1.0) then 
              do 2006  i = 1,n
                  y(iy) = x(i)
                  iy = iy + incy
2006          continue
          else
              do 2008  i = 1,n
                  y(iy) = alpha * x(i)
                  iy = iy + incy
2008          continue
          endif
c#######################################################################
c
c incx != 1 and incy == 1
c
c#######################################################################
      elseif(incy.eq.1) then 
          ix = 1
          if(alpha.eq.1.0) then 
              do 2010  i = 1,n
                  y(i) = x(ix)
                  ix = ix + incx
2010          continue
          else
              do 2012  i = 1,n
                  y(i) = alpha * x(ix)
                  ix = ix + incx
2012          continue
          endif
c#######################################################################
c
c incx != 1 and incy != 1
c
c#######################################################################
      else
          iy = 1
          if(alpha.eq.1.0) then 
              do 2014  i = 1,n,incx
                  y(iy) = x(i)
                  iy = iy + incy
2014          continue
          else
              do 2016  i = 1,n,incx
                  y(iy) = alpha * x(i)
                  iy = iy + incy
2016          continue
          endif
      endif
      return
      end
      subroutine sgeadd ( a, lda, forma, b, ldb, formb, c, ldc, m, n )
c#######################################################################
c
c Compute C = op(A) + op(B), where
c
c                 { M,           if formm == 'N'
c         op(M) = {
c                 { M transpose, if formm == 'T'
c
c Last modified:   May 7, 1992
c
c#######################################################################
c Leading dimension of matrix A
      integer lda
c Coefficients of A
      real a(lda,*)
c 'N' or 'T' for op(A)
      character*(*) forma
c Leading dimension of matrix B
      integer ldb
c Coefficients of B
      real b(ldb,*)
c 'N' or 'T' for op(B)
      character*(*) formb
c Leading dimension of matrix C
      integer ldc
c Result matrix
      real c(ldc,*)
c Rows of C
      integer m
c Columns of C
      integer n
c Local (temporary) variables
      integer i, j
c First char of forma and formb
      character*1 fma, fmb
c#######################################################################
c
c Translate the formulation of A and B
c
c#######################################################################
      fma = forma(1:1)
      fmb = formb(1:1)
      if(fma.eq.'n') then 
          fma = 'N'
      elseif(fma.eq.'t') then 
          fma = 'T'
      endif
      if(fmb.eq.'n') then 
          fmb = 'N'
      elseif(fmb.eq.'t') then 
          fmb = 'T'
c#######################################################################
c
c C = A + B
c
c#######################################################################
      endif
      if(fma.eq.'N'.and.fmb.eq.'N') then 
          do 2018  j = 1,n
              do 2020  i = 1,m
                  c(i,j) = a(i,j) + b(i,j)
2020          continue
2018      continue
c#######################################################################
c
c      T
c C = A  + B
c
c#######################################################################
      elseif(fma.eq.'T'.and.fmb.eq.'N') then 
          do 2022  j = 1,n
              do 2024  i = 1,m
                  c(i,j) = a(j,i) + b(i,j)
2024          continue
2022      continue
c#######################################################################
c
c          T
c C = A + B
c
c#######################################################################
      elseif(fma.eq.'N'.and.fmb.eq.'T') then 
          do 2026  j = 1,n
              do 2028  i = 1,m
                  c(i,j) = a(i,j) + b(j,i)
2028          continue
2026      continue
c#######################################################################
c
c      T    T
c C = A  + B
c
c#######################################################################
      elseif(fma.eq.'T'.and.fmb.eq.'T') then 
          do 2030  j = 1,n
              do 2032  i = 1,m
                  c(i,j) = a(j,i) + b(j,i)
2032          continue
2030      continue
      endif
      return
      end
      subroutine sgesub ( a, lda, forma, b, ldb, formb, c, ldc, m, n )
c#######################################################################
c
c Compute C = op(A) - op(B), where
c
c                 { M,           if formm == 'N'
c         op(M) = {
c                 { M transpose, if formm == 'T'
c
c Last modified:   May 7, 1992
c
c#######################################################################
c Leading dimension of matrix A
      integer lda
c Coefficients of A
      real a(lda,*)
c 'N' or 'T' for op(A)
      character*(*) forma
c Leading dimension of matrix B
      integer ldb
c Coefficients of B
      real b(ldb,*)
c 'N' or 'T' for op(B)
      character*(*) formb
c Leading dimension of matrix C
      integer ldc
c Result matrix
      real c(ldc,*)
c Rows of C
      integer m
c Columns of C
      integer n
c Local (temporary) variables
      integer i, j
c First char of forma and formb
      character*1 fma, fmb
c#######################################################################
c
c Translate the formulation of A and B
c
c#######################################################################
      fma = forma(1:1)
      fmb = formb(1:1)
      if(fma.eq.'n') then 
          fma = 'N'
      elseif(fma.eq.'t') then 
          fma = 'T'
      endif
      if(fmb.eq.'n') then 
          fmb = 'N'
      elseif(fmb.eq.'t') then 
          fmb = 'T'
c#######################################################################
c
c C = A - B
c
c#######################################################################
      endif
      if(fma.eq.'N'.and.fmb.eq.'N') then 
          do 2034  j = 1,n
              do 2036  i = 1,m
                  c(i,j) = a(i,j) - b(i,j)
2036          continue
2034      continue
c#######################################################################
c
c      T
c C = A  - B
c
c#######################################################################
      elseif(fma.eq.'T'.and.fmb.eq.'N') then 
          do 2038  j = 1,n
              do 2040  i = 1,m
                  c(i,j) = a(j,i) - b(i,j)
2040          continue
2038      continue
c#######################################################################
c
c          T
c C = A - B
c
c#######################################################################
      elseif(fma.eq.'N'.and.fmb.eq.'T') then 
          do 2042  j = 1,n
              do 2044  i = 1,m
                  c(i,j) = a(i,j) - b(j,i)
2044          continue
2042      continue
c#######################################################################
c
c      T    T
c C = A  - B
c
c#######################################################################
      elseif(fma.eq.'T'.and.fmb.eq.'T') then 
          do 2046  j = 1,n
              do 2048  i = 1,m
                  c(i,j) = a(j,i) - b(j,i)
2048          continue
2046      continue
      endif
      return
      end
      subroutine zyax ( n, alpha, x, incx, y, incy )
c#######################################################################
c
c Compute Y = alpha * X
c
c Last modified:   May 7, 1992
c
c#######################################################################
c Last entry to update in Y
      integer n
c Scalar multiplier
      double complex alpha
c Vector multiplicand
      double complex x(*)
c Increment for X vector
      integer incx
c Result vector
      double complex y(*)
c Increment for Y vector
      integer incy
c Local (temporary) variables
      integer i, ix, iy
c Local (temporary) variable
      double complex ax
c#######################################################################
c
c incx == 0 and incy == 1
c
c#######################################################################
      if(incx.eq.0.and.incy.eq.1) then 
          ax = alpha * x(1)
          do 2000  i = 1,n
              y(i) = ax
2000      continue
c#######################################################################
c
c incx == 1 and incy == 1
c
c#######################################################################
      elseif(incx.eq.1.and.incy.eq.1) then 
          if(alpha.eq.1.0) then 
              do 2002  i = 1,n
                  y(i) = x(i)
2002          continue
          else
              do 2004  i = 1,n
                  y(i) = alpha * x(i)
2004          continue
          endif
c#######################################################################
c
c incx == 1 and incy != 1
c
c#######################################################################
      elseif(incx.eq.1) then 
          iy = 1
          if(alpha.eq.1.0) then 
              do 2006  i = 1,n
                  y(iy) = x(i)
                  iy = iy + incy
2006          continue
          else
              do 2008  i = 1,n
                  y(iy) = alpha * x(i)
                  iy = iy + incy
2008          continue
          endif
c#######################################################################
c
c incx != 1 and incy == 1
c
c#######################################################################
      elseif(incy.eq.1) then 
          ix = 1
          if(alpha.eq.1.0) then 
              do 2010  i = 1,n
                  y(i) = x(ix)
                  ix = ix + incx
2010          continue
          else
              do 2012  i = 1,n
                  y(i) = alpha * x(ix)
                  ix = ix + incx
2012          continue
          endif
c#######################################################################
c
c incx != 1 and incy != 1
c
c#######################################################################
      else
          iy = 1
          if(alpha.eq.1.0) then 
              do 2014  i = 1,n,incx
                  y(iy) = x(i)
                  iy = iy + incy
2014          continue
          else
              do 2016  i = 1,n,incx
                  y(iy) = alpha * x(i)
                  iy = iy + incy
2016          continue
          endif
      endif
      return
      end
      subroutine zgeadd ( a, lda, forma, b, ldb, formb, c, ldc, m, n )
c#######################################################################
c
c Compute C = op(A) + op(B), where
c
c                 { M,           if formm == 'N'
c         op(M) = {
c                 { M transpose, if formm == 'T'
c
c Last modified:   May 7, 1992
c
c#######################################################################
c Leading dimension of matrix A
      integer lda
c Coefficients of A
      double complex a(lda,*)
c 'N' or 'T' for op(A)
      character*(*) forma
c Leading dimension of matrix B
      integer ldb
c Coefficients of B
      double complex b(ldb,*)
c 'N' or 'T' for op(B)
      character*(*) formb
c Leading dimension of matrix C
      integer ldc
c Result matrix
      double complex c(ldc,*)
c Rows of C
      integer m
c Columns of C
      integer n
c Local (temporary) variables
      integer i, j
c First char of forma and formb
      character*1 fma, fmb
c#######################################################################
c
c Translate the formulation of A and B
c
c#######################################################################
      fma = forma(1:1)
      fmb = formb(1:1)
      if(fma.eq.'n') then 
          fma = 'N'
      elseif(fma.eq.'t') then 
          fma = 'T'
      endif
      if(fmb.eq.'n') then 
          fmb = 'N'
      elseif(fmb.eq.'t') then 
          fmb = 'T'
c#######################################################################
c
c C = A + B
c
c#######################################################################
      endif
      if(fma.eq.'N'.and.fmb.eq.'N') then 
          do 2018  j = 1,n
              do 2020  i = 1,m
                  c(i,j) = a(i,j) + b(i,j)
2020          continue
2018      continue
c#######################################################################
c
c      T
c C = A  + B
c
c#######################################################################
      elseif(fma.eq.'T'.and.fmb.eq.'N') then 
          do 2022  j = 1,n
              do 2024  i = 1,m
                  c(i,j) = a(j,i) + b(i,j)
2024          continue
2022      continue
c#######################################################################
c
c          T
c C = A + B
c
c#######################################################################
      elseif(fma.eq.'N'.and.fmb.eq.'T') then 
          do 2026  j = 1,n
              do 2028  i = 1,m
                  c(i,j) = a(i,j) + b(j,i)
2028          continue
2026      continue
c#######################################################################
c
c      T    T
c C = A  + B
c
c#######################################################################
      elseif(fma.eq.'T'.and.fmb.eq.'T') then 
          do 2030  j = 1,n
              do 2032  i = 1,m
                  c(i,j) = a(j,i) + b(j,i)
2032          continue
2030      continue
      endif
      return
      end
      subroutine zgesub ( a, lda, forma, b, ldb, formb, c, ldc, m, n )
c#######################################################################
c
c Compute C = op(A) - op(B), where
c
c                 { M,           if formm == 'N'
c         op(M) = {
c                 { M transpose, if formm == 'T'
c
c Last modified:   May 7, 1992
c
c#######################################################################
c Leading dimension of matrix A
      integer lda
c Coefficients of A
      double complex a(lda,*)
c 'N' or 'T' for op(A)
      character*(*) forma
c Leading dimension of matrix B
      integer ldb
c Coefficients of B
      double complex b(ldb,*)
c 'N' or 'T' for op(B)
      character*(*) formb
c Leading dimension of matrix C
      integer ldc
c Result matrix
      double complex c(ldc,*)
c Rows of C
      integer m
c Columns of C
      integer n
c Local (temporary) variables
      integer i, j
c First char of forma and formb
      character*1 fma, fmb
c#######################################################################
c
c Translate the formulation of A and B
c
c#######################################################################
      fma = forma(1:1)
      fmb = formb(1:1)
      if(fma.eq.'n') then 
          fma = 'N'
      elseif(fma.eq.'t') then 
          fma = 'T'
      endif
      if(fmb.eq.'n') then 
          fmb = 'N'
      elseif(fmb.eq.'t') then 
          fmb = 'T'
c#######################################################################
c
c C = A - B
c
c#######################################################################
      endif
      if(fma.eq.'N'.and.fmb.eq.'N') then 
          do 2034  j = 1,n
              do 2036  i = 1,m
                  c(i,j) = a(i,j) - b(i,j)
2036          continue
2034      continue
c#######################################################################
c
c      T
c C = A  - B
c
c#######################################################################
      elseif(fma.eq.'T'.and.fmb.eq.'N') then 
          do 2038  j = 1,n
              do 2040  i = 1,m
                  c(i,j) = a(j,i) - b(i,j)
2040          continue
2038      continue
c#######################################################################
c
c          T
c C = A - B
c
c#######################################################################
      elseif(fma.eq.'N'.and.fmb.eq.'T') then 
          do 2042  j = 1,n
              do 2044  i = 1,m
                  c(i,j) = a(i,j) - b(j,i)
2044          continue
2042      continue
c#######################################################################
c
c      T    T
c C = A  - B
c
c#######################################################################
      elseif(fma.eq.'T'.and.fmb.eq.'T') then 
          do 2046  j = 1,n
              do 2048  i = 1,m
                  c(i,j) = a(j,i) - b(j,i)
2048          continue
2046      continue
      endif
      return
      end
